package org.gcube.common.iam;

import java.util.Set;

import org.gcube.common.keycloak.model.AccessToken;

public interface IAMResponse {

    public AccessToken getAccessToken() throws D4ScienceIAMClientException;

    String getAccessTokenString();

    boolean isExpired() throws D4ScienceIAMClientException;

    boolean canBeRefreshed() throws D4ScienceIAMClientException;

    void refresh() throws D4ScienceIAMClientException;

    String getContactOrganization() throws D4ScienceIAMClientException;

    String getContactPerson() throws D4ScienceIAMClientException;

    String getName() throws D4ScienceIAMClientException;

    Set<String> getAudienceResourceRoles() throws D4ScienceIAMClientException;

    Set<String> getResourceRoles(String resource) throws D4ScienceIAMClientException;

    Set<String> getRoles() throws D4ScienceIAMClientException;

    Set<String> getRealmRoles() throws D4ScienceIAMClientException;

}